Index: trunk/VUT/work/ogre_changes/OgreMain/include/OgreSceneManager.h
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/include/OgreSceneManager.h	(revision 159)
+++ trunk/VUT/work/ogre_changes/OgreMain/include/OgreSceneManager.h	(revision 183)
@@ -161,4 +161,8 @@
 		*/
 		void _renderMovableObject(MovableObject *mov, const int leavePassesInQueue);
+
+		/** Renders a single renderable using pass 0 of the renderable.
+		*/
+		void _renderSingleRenderable(Renderable *rend);
 
 		/** Tells the scene manager that the frame ends (i.e.,
Index: trunk/VUT/work/ogre_changes/OgreMain/src/OgreSceneManager.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/src/OgreSceneManager.cpp	(revision 139)
+++ trunk/VUT/work/ogre_changes/OgreMain/src/OgreSceneManager.cpp	(revision 183)
@@ -4248,4 +4248,11 @@
 	SceneManager::_renderVisibleObjects();
 }
+//-----------------------------------------------------------------------
+void SceneManager::_renderSingleRenderable(Renderable *rend)
+{
+	Pass *pass = rend->getTechnique()->getPass(0);
+	setPass(pass);
+	renderSingleObject(rend, pass, false);
+}
 #endif //GTP_VISIBILITY_MODIFIED_OGRE
 }
Index: trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctreeNode.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctreeNode.cpp	(revision 166)
+++ trunk/VUT/work/ogre_changes/Plugins/OctreeSceneManager/src/OgreOctreeNode.cpp	(revision 183)
@@ -189,5 +189,5 @@
 	AxisAlignedBox box = mLocalAABB;
 	// HACK: scale should not be done here
-	box.scale(Vector3(10,10,10));
+	box.scale(Vector3(3, 3, 3));
 	mWireBoundingBox->setupBoundingBox(box);
 	mWireBoundingBox->getRenderOperation(rend);
Index: trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9RenderWindow.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9RenderWindow.cpp	(revision 171)
+++ trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9RenderWindow.cpp	(revision 183)
@@ -366,5 +366,5 @@
 		md3dpp.BackBufferHeight			= mHeight;
 #ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	md3dpp.Flags |= D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;
+	//md3dpp.Flags |= D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;
 #endif
 		if (mVSync)
@@ -938,5 +938,5 @@
 		// this will be the dimensions of the front buffer
 		if (FAILED(hr = mpD3DDevice->GetDisplayMode(0, &dm)))
-			OGRE_EXCEPT(hr, "Can't get display mode!", "D3D9RenderWindow::writeContentsToFile");
+			OGRE_EXCEPT(hr, "Can't get display mode!", "D3D9RenderWindow::getBufferContents");
 
 		desc.Width = dm.Width;
@@ -951,5 +951,5 @@
 						NULL)))
 		{
-			OGRE_EXCEPT(hr, "Cannot create offscreen buffer 1!", "D3D9RenderWindow::writeContentsToFile");
+			OGRE_EXCEPT(hr, "Cannot create offscreen buffer 1!", "D3D9RenderWindow::getBufferContents");
 		}
 
@@ -971,5 +971,5 @@
 			desc.Format = D3DFMT_A8R8G8B8;         // this is what we get from the screen, so stick with it
 
-			// NB we can't lock the back buffer direct because it's no created that way
+			// NB we can't lock the back buffer direct because it's not created that way
 			// and to do so hits performance, so copy to another surface
 			// Must be the same format as the source surface
@@ -983,5 +983,5 @@
 			{
 				SAFE_RELEASE(pSurf);
-				OGRE_EXCEPT(hr, "Cannot create offscreen buffer 2!", "D3D9RenderWindow::writeContentsToFile");
+				OGRE_EXCEPT(hr, "Cannot create offscreen buffer 2!", "D3D9RenderWindow::getBufferContents");
 			}
 
@@ -991,5 +991,5 @@
 				SAFE_RELEASE(pTempSurf);
 				SAFE_RELEASE(pSurf);
-				OGRE_EXCEPT(hr, "Cannot update surface!", "D3D9RenderWindow::writeContentsToFile");
+				OGRE_EXCEPT(hr, "Cannot update surface!", "D3D9RenderWindow::getBufferContents");
 			}
 
@@ -1003,5 +1003,5 @@
 			D3DLOCK_READONLY | D3DLOCK_NOSYSLOCK)))
 		{
-			OGRE_EXCEPT(hr, "can't lock rect!", "D3D9RenderWindow::writeContentsToFile");
+			OGRE_EXCEPT(hr, "can't lock rect!", "D3D9RenderWindow::getBufferContents");
 		} 
 