Index: /trunk/VUT/GtpVisibilityPreprocessor/include/ViewCellBSP.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/include/ViewCellBSP.h	(revision 190)
+++ /trunk/VUT/GtpVisibilityPreprocessor/include/ViewCellBSP.h	(revision 194)
@@ -1,4 +1,6 @@
 #ifndef _ViewCellBsp_H__
 #define _ViewCellBsp_H__
+
+#include "Containers.h"
 
 class ViewCell;
@@ -15,17 +17,20 @@
   {
   public:
-    /** Determines whether this node is a leaf or not
-	@return true if leaf
-    */
-    virtual bool IsLeaf() const = 0;
+	  /** Determines whether this node is a leaf or not
+	  @return true if leaf
+	  */
+	  virtual bool IsLeaf() const = 0;
     
-    /** Determines whether this node is a root
-	@return true if root
-    */
-    virtual bool IsRoot();
+	  /** Determines whether this node is a root
+	  @return true if root
+	  */
+	  virtual bool IsRoot();
+  
+  protected:
 
-  protected:
-    /// parent of this node
-    BSPInterior *mParent;
+	  void SplitPoly(Plane3 *plane, Mesh *viewcell);
+
+	  /// parent of this node
+	  BSPInterior *mParent;
   };
 
@@ -33,14 +38,14 @@
   class BSPInterior : public BSPNode 
   {    
-    /** @return false since it is an interior node */
-    bool IsLeaf() const;
+	/** @return false since it is an interior node */
+	bool IsLeaf() const;
 
-  protected:
-    /// Splitting plane corresponding to this node
-    Plane3 mPlane;
-    /// back node
-    BSPNode *mBack;
-    /// front node
-    BSPNode *mFront;
+	protected:
+	/// Splitting plane corresponding to this node
+	Plane3 mPlane;
+	/// back node
+	BSPNode *mBack;
+	/// front node
+	BSPNode *mFront;
   };
   
@@ -50,12 +55,12 @@
   {
   public:
-	BSPLeaf(ViewCell *viewCell = NULL);
-    /** @return true since it is an interior node */
-    virtual bool IsLeaf();
+	  BSPLeaf(ViewCell *viewCell = NULL);
+	  /** @return true since it is an interior node */
+	  virtual bool IsLeaf();
 
   protected:
-    /// polygonal representation of this viewcell
-    /// if NULL this note does not correspond to feasible viewcell
-    ViewCell *mViewCell;
+	  /// polygonal representation of this viewcell
+	  /// if NULL this note does not correspond to feasible viewcell
+	  ViewCell *mViewCell;
   };
   
@@ -64,13 +69,13 @@
   {
   public:
-    /** Constructor takes a pointer to the cell corresponding to the whole
-	viewspace */
-    BSPTree(ViewCell *cell);
+	  /** Constructor takes a pointer to the cell corresponding to the whole
+	  viewspace */
+	  BSPTree(ViewCell *cell);
         
   protected:
-    /// Pointer to the root of the tree
-    BSPNode *mRoot;
-    /// Pointer to the root cell of the viewspace */
-    ViewCell *mRootCell;
+	  /// Pointer to the root of the tree
+	  BSPNode *mRoot;
+	  /// Pointer to the root cell of the viewspace */
+	  ViewCell *mRootCell;
   };
   
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBSP.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBSP.h	(revision 190)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBSP.h	(revision 194)
@@ -4,16 +4,17 @@
 class ViewCell;
 class Plane3;
+class Mesh;
 
 //namespace GtpVisibilityPreprocessor {
   
-  class BSPInterior;
+class BSPInterior;
 
-  /**
-     BSPNode abstract class serving for interior and leaf node implementation
-  */
-  class BSPNode 
-  {
-  public:
-    /** Determines whether this node is a leaf or not
+/**
+	BSPNode abstract class serving for interior and leaf node implementation
+*/
+class BSPNode 
+{
+public:
+	/** Determines whether this node is a leaf or not
 	@return true if leaf
     */
@@ -25,5 +26,8 @@
     virtual bool IsRoot() const;
 
-  protected:
+	protected:
+
+		void SplitPoly(Plane3 *plane, Mesh *viewcell);
+
     /// parent of this node
     BSPInterior *mParent;
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 190)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 194)
@@ -1,4 +1,5 @@
 #include "Plane3.h"
 #include "ViewCellBsp.h"
+#include "Mesh.h"
 
 class ViewCell;
@@ -9,4 +10,8 @@
 {
 	return mParent == NULL;
+}
+
+void BSPNode::SplitPoly(Plane3 *plane, Mesh *viewcell)
+{
 }
 